; Moveable WS_EX_TRANSPARENT-Static

.386
.model flat,stdcall
option casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

.data
_class       db "just_parent_window",0
_static      db "Static",0
_edit        db "Edit",0
_button      db "Button",0
_button_text db "Send  text  from  Edit  to  Static !",0
_edit_text   db "It's very easy to work with WS_EX_TRANSPARENT :-)",0
_static_text db "  Moveable  WS_EX_TRANSPARENT - Static",0
_about       db "by kero <geocities.com/xmemor>, v.2006-09-19",0

.data?
hInstance    HINSTANCE ?
hw_static    HWND ?
hw_edit      HWND ?
hbrush       HBRUSH ?
oldwndproc   dd ?
flag         dd ?

.code

NewWndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_SETTEXT || uMsg==WM_GETICON
		invoke CallWindowProc,oldwndproc,hWnd,uMsg,wParam,lParam
@@:
		invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOSENDCHANGING OR SWP_FRAMECHANGED OR SWP_NOZORDER

	.elseif (uMsg==WM_MOVE && flag==0) || (uMsg==WM_WINDOWPOSCHANGING && flag!=0)
		jmp @b

	.elseif uMsg==WM_LBUTTONDBLCLK
		xor flag,1

	.elseif uMsg==WM_LBUTTONDOWN
		invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOSENDCHANGING OR SWP_FRAMECHANGED OR SWP_NOZORDER
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.else
		invoke CallWindowProc,oldwndproc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
NewWndProc endp


WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local buf[MAX_PATH+1]:BYTE

	.if uMsg==WM_DESTROY
		invoke DeleteObject,hbrush
		invoke PostQuitMessage,0

	.elseif uMsg==WM_CREATE
		invoke CreateWindowEx,WS_EX_TRANSPARENT,\
													offset _static,offset _static_text,\
													WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or SS_NOTIFY,\
													90,190,210,140,\
													hWnd,2000,hInstance,0
		mov hw_static,eax
		invoke SetWindowLong,hw_static,GWL_WNDPROC,addr NewWndProc
		mov oldwndproc,eax

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,\
													offset _edit,offset _edit_text,\
													WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_MULTILINE or ES_WANTRETURN,\
													20,50,350,30,\
													hWnd,3000,hInstance,0
		mov hw_edit,eax

		invoke CreateWindowEx,0,\
													offset _button,offset _button_text,\
													WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS,\
													55,120,280,30,\
													hWnd,4000,hInstance,0

	.elseif uMsg==WM_CTLCOLORSTATIC
		mov eax,0000ffh
		invoke SetTextColor,wParam,eax
		invoke SetBkMode,wParam,TRANSPARENT
		invoke GetStockObject,NULL_BRUSH
		ret

	.elseif uMsg==WM_COMMAND && wParam==4000
		invoke SendMessage,hw_edit,WM_GETTEXT,MAX_PATH,addr buf
		invoke SendMessage,hw_static,WM_SETTEXT,0,addr buf

	.elseif uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_ACTIVATE
		invoke SetWindowPos,hw_static,HWND_TOP,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOSENDCHANGING OR SWP_FRAMECHANGED

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local msg:MSG
	local hwnd:HWND
	local hBitmap:HBITMAP

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_DBLCLKS
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	push hInst
	pop wc.hInstance

	invoke LoadImage,hInst,600,IMAGE_BITMAP,400,400,LR_DEFAULTCOLOR
	mov hBitmap,eax
	invoke CreatePatternBrush,eax
	mov hbrush,eax
	mov wc.hbrBackground,eax
	invoke DeleteObject,hBitmap

	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset _class
;	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon,0
	mov wc.hIconSm,0
	invoke  LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW,\
												offset _class,offset _static_text,\
												WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\
												100,100,400,400,\
												0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,SW_SHOWNORMAL
	invoke UpdateWindow,hwnd

	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp


start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start

; ws_ex_transparent.rc
; 600 BITMAP "Bitmap_1.bmp"
